/**
 * Fall 2014 CS3101-2 - Programming Languages: Scala
 * Problem Set 1, Part 1
 * 
 * Using the function collatz, write a function longest collatz, that takes an 
 * integer n as its parameter and return the positive integer m, m <= n for 
 * which collatz needs the largest number of steps. Add your function to the 
 * file Collatz.scala.
 *
 * Answer the following questions as comments at the end of Collatz.scala:
 *
 *   - Which number m, m <= 1000, produces the longest Collatz sequence? How 
 *     many steps are in this sequence?
 *   - For very large n (e.g. n = 1, 000, 000) the naive implementation of 
 *     longest collatz becomes very slow. Explain why. Describe (in words) 
 *     how you could improve the function to terminate faster (you do not
 *     have to implement a better solution at this point. The naive one
 *     is fine).
 */

def collatz_rec(n: Int, counter: Int) : Int = 
    if (n == 1) 
        counter 
    else if (n % 2 == 0) 
        collatz_rec(n / 2, counter + 1)
    else 
        collatz_rec(n * 3 + 1, counter + 1)

def collatz(n:Int) : Int = collatz_rec(n, 0)


// Your code here
def longest_collatz(n : Int) : Int = {
    var longest_steps = 0
    var longest_n = 1
    var i = 1
    do {
        val new_steps = collatz(i)
        if (new_steps > longest_steps) { 
            longest_steps = new_steps
            longest_n = i
        }
        i += 1
    } while (i<n)
    println("Longest N:"+ longest_n + " Steps: "+longest_steps)
    longest_n 
}

longest_collatz(1000)
/* 
 * Answers to your questions here
 * - The longest Collatz Sequence for any number below takes 178 steps for n=871.
 * 
 * - The function longest_collatz  has an efficiency issue. For every number i, 
 *   we recompute the entire Collatz sequence for this number. For instance, if 
 *   we compute the Collatz sequence for i=5 (10 5 16 8 4 2 1) the prefix 
 *   (5 16 8 4 2 1) has already been computed once. 
 */
